<?php

namespace App\Http\Requests;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use App\TrainReservation;

class TrainReservationRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
   public function authorize()
    {
        $role = [NULL];
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role_id, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('users'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $request = request();
        
          if ($this->method() == "POST") {
            $reservation = TrainReservation::where('trainner_id',$request->trainner_id)->where('dating',$request->dating)->where('timing',$request->timing)->first();
        }
        else{
            $reservation = TrainReservation::where('id','!=',$request->id)->where('trainner_id',$request->trainner_id)->where('dating',$request->dating)->where('timing',$request->timing)->first();
        
        }
        
        $rules=[
            'trainner_id'=> 'required',
            'branch_id'=>'required',
            'patient_id'=> 'required',
            'dating'=> 'required',
            'timing'=> 'required',

            
        ];
       if($reservation){
           $rule=['picked'=>'required'];
           $rules = array_merge($rules, $rule);
       }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        
        $attributes= [
            'trainner_id'=> __('trainreservations.trainner'),
            'patient_id'=> __('trainreservations.patient'),
            'dating'=> __('trainreservations.dating'),
            'timing'=> __('trainreservations.timing'),
            'picked'=>__('trainreservations.picked'),
            'branch_id'=>__('reservations.branch'),
        
        ];
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
